
#include <gpstdio.h>
#include <defines.h>
#include <gpmem.h>
#include "../../cap32.h"
#include <gpstdlib.h>


//DEFINES
#define UP_PRESSED 0
#define RIGHT_PRESSED 1
#define DOWN_PRESSED 2
#define LEFT_PRESSED 3
#define A_PRESSED 4
#define B_PRESSED 5
//#define START_PRESSED 6
//#define SELECT_PRESSED 7
#define LSHOULDER_PRESSED 8
#define RSHOULDER_PRESSED 9


GPDIRENTRY * direntry;
 extern const unsigned char menu_p[76800];
 
 extern Pituka_SpoolKeys spoolkeys;
 extern char extension[5];
 /*
 unsigned char pos=1, ini=0;
 ulong read_count=0, n=100;
 bool cambia=1,seleccionado=0;
 */
 
 //Variables del seleccionador: SEL_
 unsigned char SEL_pos=1, SEL_ini=0;
 ulong SEL_read_count=0, SEL_n=100;
 bool SEL_cambia=1,SEL_seleccionado=0;
 
 //Variables del explorador: EXP_
 unsigned char EXP_pos=1, EXP_ini=0;
 ulong EXP_read_count=0, EXP_n=100;
 bool EXP_cambia=1,EXP_seleccionado=0;
 
 
 
 
#define MAX_FILES 8
 
 void poll_keymenu(int modo) {
	static cpc_dword last_pbdat=0;
//	static cpc_dword last_pedat=0;
	cpc_dword current_pbdat;
//	cpc_dword current_pedat;

	if(!last_pbdat) last_pbdat=(*(volatile cpc_dword *)0x1560000c);
//	if(!last_pedat) last_pedat=(*(volatile cpc_dword *)0x15600030);

	current_pbdat=(*(volatile cpc_dword *)0x1560000c);
	current_pbdat&=0x0000ff00;
//	current_pedat=(*(volatile cpc_dword *)0x15600030);
//	current_pedat&=0x000000c0;


  switch(modo) {
  //Cuando es 1 esta en CATALOGO (SELECCIONANDO)
  //Cuando es 0 esta en el EXPLORADOR

	case 0:
	 if(current_pbdat!=last_pbdat) {
			/* left */
		if((current_pbdat^last_pbdat)&0x00000100) {
			if(current_pbdat&0x00000100) {
			//yata
			} else {
				 if((EXP_ini-8)>0){
					 EXP_ini-=8;
					 EXP_cambia=1;
				 }else{
					 EXP_ini=0;
					 EXP_pos=1;
					 EXP_cambia=1;
				}
			}
		}
				/* right */
		if((current_pbdat^last_pbdat)&0x00000400) {
			if(current_pbdat&0x00000400) {
				//wey
			} else {
				 if(EXP_read_count>(EXP_ini+(EXP_pos+8)+1)){
					 EXP_ini+=8;
					 EXP_cambia=1;
				}else{
					EXP_ini=EXP_read_count-1;
					EXP_pos=0;
					EXP_cambia=1;
				}
			}
		}
		/* up */ 
		if((current_pbdat^last_pbdat)&0x00000800) {
			if(current_pbdat&0x00000800) {
					 //sale como 2 veces :?
		 }else{
			 if((EXP_pos<1)){
				 if(EXP_ini){
					 EXP_ini--;
					 EXP_cambia=1;
				 }
				 }else{
					 EXP_pos--;
					 EXP_cambia=1;
				}
		 
		 }
		}
		/* down */
		if((current_pbdat^last_pbdat)&0x00000200) {
			if(current_pbdat&0x00000200) {
			//sale como 2 veces :?
 			} else {
			 if(EXP_pos>6){
				 if(EXP_read_count>(EXP_ini+EXP_pos+1)){
					 EXP_ini++;
					 EXP_cambia=1;
				}
			 }else if((EXP_ini+EXP_pos+1)<EXP_read_count){
				 EXP_pos++;
				 EXP_cambia=1;
			}
			}
		}
		
		if((current_pbdat^last_pbdat)&0x00002000) {
			if(current_pbdat&0x00002000) {
				//process_input(0, B_PRESSED);
						//EXP_pos=EXP_ini=0;
						EXP_seleccionado=2;
			} else {
				//process_input(1, B_PRESSED);
				}
		}

		/* button A */
		if((current_pbdat^last_pbdat)&0x00004000) {
			if(current_pbdat&0x00004000) {
//				process_input(0, A_PRESSED);
					if (((gm_compare(direntry[(EXP_pos+EXP_ini)].name,".")!=0) && (gm_compare(direntry[(EXP_pos+EXP_ini)].name,"..")!=0))) {
						EXP_seleccionado=1;
					}
			}
		}
		last_pbdat=current_pbdat;
	  }
	break;
	
	case 1:
	  if(current_pbdat!=last_pbdat) {
			/* left */
		if((current_pbdat^last_pbdat)&0x00000100) {
			if(current_pbdat&0x00000100) {
			//yata
			} else {
				 if(((SEL_ini-8)>0)&&(SEL_ini)){
					 SEL_ini-=8;
					 SEL_cambia=1;
				 }else{
					 SEL_ini=0;
					 SEL_pos=0;
					 SEL_cambia=1;
				}
			}
		}
				/* right */
		if((current_pbdat^last_pbdat)&0x00000400) {
			if(current_pbdat&0x00000400) {
				//wey
			} else {
				 if(SEL_read_count>(SEL_ini+(SEL_pos+8)+1)){
					 SEL_ini+=8;
					 SEL_cambia=1;
				}else{
					SEL_ini=SEL_read_count-1;
					SEL_pos=0;
					SEL_cambia=1;
				}
			}
		}
		/* up */ 
		if((current_pbdat^last_pbdat)&0x00000800) {
			if(current_pbdat&0x00000800) {
					 //sale como 2 veces :?
		 }else{
			 if((SEL_pos<1)){
				 if(SEL_ini){
					 SEL_ini--;
					 SEL_cambia=1;
				 }
				 }else{
					 SEL_pos--;
					 SEL_cambia=1;
				}
		 
		 }
		}
		/* down */
		if((current_pbdat^last_pbdat)&0x00000200) {
			if(current_pbdat&0x00000200) {
			//sale como 2 veces :?
 			} else {
			 if(SEL_pos>6){
				 if(SEL_read_count>(SEL_ini+SEL_pos+1)){
					 SEL_ini++;
					 SEL_cambia=1;
				}
			 }else if((SEL_ini+SEL_pos+1)<SEL_read_count){
				 SEL_pos++;
				 SEL_cambia=1;
			}
			}
		}
		
		if((current_pbdat^last_pbdat)&0x00002000) {
			if(current_pbdat&0x00002000) {
				//process_input(0, B_PRESSED);
						//SEL_pos=SEL_ini=0;
						//podiamos usar este para salir
						SEL_seleccionado=1;
			} else {
				//process_input(1, B_PRESSED);
				}
		}

		/* button A */
		if((current_pbdat^last_pbdat)&0x00004000) {
			if(current_pbdat&0x00004000) {
//				process_input(0, A_PRESSED);
						//SEL_pos=SEL_ini=0;
						SEL_seleccionado=1;
			}
		}
		last_pbdat=current_pbdat;
	  }
	break;

	
  }
}
 
  
 void pituka_catalogo(char * fichero){
	 char path[50]="gp:\\gpmm\\amstrad\\disks\\";
	 char Buffer[256]="\0";
	 char contenido[50][20];
	 int n=0,i=0,j=0,temp=0,o=0;
	 ulong leido=0;
     unsigned char * LCD = (unsigned char *)0x0c7b4000;
	 unsigned char c=0;
	 char chStr[40];
	 byte tracks=0, sides=0,disco[50];
	 //int vecesencontrados=0,vecesleidos=0;
	 char dtipo='O';
	 bool derror= FALSE ;

		
	 
	 //LEEMOS EL FICHERO
	 gm_strcat(path,fichero);
	 F_HANDLE pfile;
	 if (GpFileOpen (path, OPEN_R, &pfile)==SM_OK) {
		  	 gm_strcpy(contenido[0],"|cpm");
		  //ponemos |CPM en la posicion -> 0
		
			 GpFileRead ((F_HANDLE)pfile, (char*)Buffer, (int) 0x100, (ulong*)&leido);
	      if (gm_memcmp(Buffer, "EXTENDED", 8) == 0) { // extended DSK image?
		  
		  	// gm_strcpy(contenido[0],"EXTENDED");
			dtipo='X';

			 tracks = *(Buffer + 0x30); sides=*(Buffer + 0x31);
			  for(o=0;o<tracks*sides;o++) disco[o]=*(Buffer + 0x34+ o); //asi completamos cada cara y sabemos el tamao de cada una
		 }else{
			 dtipo='A';
			 tracks = *(Buffer + 0x30); sides=*(Buffer + 0x31);
			  for(o=0;o<tracks*sides;o++) disco[o]=/*(*(Buffer + 0x32))+(*/*(Buffer + 0x33)/**0x100)*/; //asi completamos cada cara y sabemos el tamao de cada una
				  //lo dejamos asi por compatibilidad, solo hay un tamao igual para todos
		 }
			 //la primera vez
			  GpFileSeek((F_HANDLE)pfile, FROM_BEGIN, 0x100, 0); //saltamos la cabeceras fichero...
			  
			  for(n=1,o=0;o<tracks*sides;o++){
				  //GpFileSeek((F_HANDLE)pfile, FROM_BEGIN, (0x200+(disco[o]*0x100)+0x100), 0); //saltamos al track y leemos
				  //GpFileSeek((F_HANDLE)pfile, FROM_BEGIN, (0x200+((disco[o]*0x100)*o)), 0); //menos las 2 cabeceras fichero y file-track ese... 
				  GpFileSeek((F_HANDLE)pfile, FROM_CURRENT, 0x100, 0); //saltamos la cabecera: file-track
				  //vecesleidos++; //hemos leido una vez mas
				  for(temp=0;temp<disco[o]*0x100;temp+=0x20){
					  derror=FALSE;
					  GpFileRead ((F_HANDLE)pfile, (char*)Buffer, (int) 0x20, (ulong*)&leido);
					  //if(((Buffer[0]==0x00)&&(Buffer[9]==0xa0))||((Buffer[0]==0x00)&&(Buffer[9]==0x42))) //Si tiene B o blanco y empieza por 00
					  if(((Buffer[0]==0x00)&&((Buffer[9]==0xa0)||(Buffer[9]==0x20))&&(Buffer[10]==0x20)&&(Buffer[11]==0x20)&&(Buffer[15]!=0x00))
					  ||((Buffer[0]==0x00)&&((((Buffer[9]==0x42)||(Buffer[9]==0xC2))&&(Buffer[10]==0x41))||(((Buffer[9]==0x42)||(Buffer[9]==0xC2))&&(Buffer[10]==0x49)))&&(Buffer[15]!=0x00))) //Si tiene B o blanco y empieza por 00
					  {
						  //vecesencontrados++;
						  for(i=1,j=0;((Buffer[i]!=0x20)&&(i<9));i++,j++){
							  if(((Buffer[i]>='A')&&(Buffer[i]<='Z'))||((Buffer[i]>='0')&&(Buffer[i]<='9'))||
							  (Buffer[i]=='-')||(Buffer[i]=='!')||(Buffer[i]=='{')||(Buffer[i]=='}')||(Buffer[i]=='\'')||(Buffer[i]=='&')||
							  (Buffer[i]=='^')||(Buffer[i]=='@')||(Buffer[i]=='+')||(Buffer[i]=='#'))
								  chStr[j]=Buffer[i];
							  else{
								  //chStr[j]=Buffer[i];
								  derror=TRUE;
							  }
						  } //copiamos el nombre del fichero
						  if(derror){
						    continue;
							//  chStr[j]='x'; // "." de la extension
						  }//else{
							  chStr[j]='.'; // "." de la extension
						//  }
							
							  
						  //chStr[j]='.'; // "." de la extension
						  while(Buffer[i]==0x20) i++; //saltamos los espacios
						  
						  if(Buffer[i]==0x42){ //ficheros BAS, BIN, B**
							 for(j++;((Buffer[i]!=0x00)&&(i<12));i++,j++) //mientras no sea fin de fila
							 chStr[j]=Buffer[i];
							 chStr[j]='\0';
							 gm_strcpy(contenido[n],chStr);
							 if(gm_compare(contenido[n],contenido[n-1])!=0) //no son iguales
								 n++;
						 }else if((Buffer[i]==0xa0)||(Buffer[9]==0x20)){ //ficheros que solo tienen un punto
							 //fin de cadena
							 j++;
							 chStr[j]='\0';
							 gm_strcpy(contenido[n],chStr);
							 if(gm_compare(contenido[n],contenido[n-1])!=0) //no son iguales
								  n++;
						 }else if(Buffer[i]==0xC2){
							 Buffer[i]=0x42; //lo cambiamos a B 
							 for(j++;((Buffer[i]!=0x00)&&(i<12));i++,j++) //mientras no sea fin de fila
							 chStr[j]=Buffer[i];
							 chStr[j]='\0';
							 gm_strcpy(contenido[n],chStr);
							 if(gm_compare(contenido[n],contenido[n-1])!=0) //no son iguales
								 n++;
						 }
					}
				  }
			  }
		 /*}else{
		 
		  GpFileSeek((F_HANDLE)pfile, FROM_BEGIN, 0x200, 0); //saltamos la cabecera
		 
		 for(n=1;Buffer[0]!=0xE5;){ // hasta fin de catalogo
			 GpFileRead ((F_HANDLE)pfile, (char*)Buffer, (int) 0x20, (ulong*)&leido);
			 //empezamos con buffer+1 por que el primero no es un char
			 for(i=1,j=0;((Buffer[i]!=0x20)&&(i<9));i++,j++) //mientras no sea espacio
				 chStr[j]=Buffer[i];
			 //metemos el "." de la extension
			 //j++;
			 chStr[j]='.';
			 
			 while(Buffer[i]==0x20) i++; //saltamos los espacios
			 
			 if(Buffer[i]==0x42){ //ficheros BAS, BIN, B**
				 for(j++;((Buffer[i]!=0x00)&&(i<12));i++,j++) //mientras no sea fin de fila
					 chStr[j]=Buffer[i];
				 chStr[j]='\0';
				 gm_strcpy(contenido[n],chStr);
				 if(gm_compare(contenido[n],contenido[n-1])!=0) //no son iguales
					 n++;
			 }else if((Buffer[i]==0xa0)||(Buffer[9]==0x20)){ //ficheros que solo tienen un punto
				 //fin de cadena
				 j++;
				 chStr[j]='\0';
				 gm_strcpy(contenido[n],chStr);
				 if(gm_compare(contenido[n],contenido[n-1])!=0) //no son iguales
					 n++;
			 }else if(Buffer[i]==0xC2){
							 Buffer[i]=0x42; //lo cambiamos a B 
							 for(j++;((Buffer[i]!=0x00)&&(i<12));i++,j++) //mientras no sea fin de fila
							 chStr[j]=Buffer[i];
							 chStr[j]='\0';
							 gm_strcpy(contenido[n],chStr);
							 if(gm_compare(contenido[n],contenido[n-1])!=0) //no son iguales
								 n++;
						 }
		 }
		 
	  }*/	 
		 GpFileClose((F_HANDLE)pfile);
	 }

	 //nos preparamos
	 SEL_read_count=n; //numero de ficheros leidos
	 SEL_pos=0, SEL_ini=0;
	 
	 
	 //IMPRIMIMOS LOS RESULTADOS Y ESPERAMOS A QUE EL USUARIO ELIJA
	 while(!SEL_seleccionado){ //no seleccionado
		 
		 poll_keymenu(1);
		 
		 if(SEL_cambia){
		 
			 for(SEL_n=0;SEL_n<76800;SEL_n++,LCD++)*LCD=menu_p[SEL_n];
			 LCD = (unsigned char *)0x0c7b4000;
			 print((cpc_byte *)LCD+((GPC_LCD_HEIGHT*100)+180), (char*)".: SELECT FILE :.", false); // LETRITAS :D
			 //print((cpc_byte *)LCD+((GPC_LCD_HEIGHT*10)+170), (char*)path, false); // LETRITAS :D
			 
			 for(c=0,SEL_n=SEL_ini;((SEL_n<SEL_read_count)&&(c<MAX_FILES));SEL_n++){
				 print((cpc_byte *)LCD+((GPC_LCD_HEIGHT*100)+155-(c*10)), contenido[SEL_n], true); // LETRITAS :D
				 c++;
			 }
	 
			 print((cpc_byte *)LCD+((GPC_LCD_HEIGHT*90)+155-(SEL_pos*10)), (char*)">", false); // LETRITAS :D
			 print((cpc_byte *)LCD+((GPC_LCD_HEIGHT*80)+65), (char*)"( EXT: .BAS .BIN . )", false); // LETRITAS :D
			 
	 			//gm_sprintf(chStr,"R: %i N: %i P: %i I: %i Tipo: %c", (int)SEL_read_count, (int)SEL_n, SEL_pos, SEL_ini, dtipo); //para hacer el spool de comandos...
				//print((cpc_byte *)LCD+((GPC_LCD_HEIGHT*3)+10), (char*)chStr, true); // SPOOL

			 SEL_cambia=0;
		 }
	 }
	 
	 
		 gm_strcpy ( path, contenido[(SEL_pos+SEL_ini)] ); //usamos temporalmente path
		 gm_lowercase(path,gm_lstrlen(path));
		 
		if(SEL_pos+SEL_ini!=0)
			gm_strcpy(spoolkeys.contenido,"run|");
		gm_strcat(spoolkeys.contenido,path);
		spoolkeys.comienzo=TRUE;
	 
	 
 }
 
 
  int explora (char * fichero){
  unsigned char c=0;
  char path[35]="gp:\\gpmm\\amstrad\\disks\\";
  ERR_CODE error;
  unsigned char * LCD = (unsigned char *)0x0c7b4000;

	if((error = GpDirEnumNum ((char *)path, &EXP_n))!=SM_OK)
  {
    return error;
  }
    
	direntry = gm_malloc ( sizeof(GPDIRENTRY)*EXP_n );
	GpDirEnumList ( (char *)path, 0, EXP_n, direntry, &EXP_read_count );


 
 
 //while((tecla=GpKeyGet())!=0x40){
 
 while(!EXP_seleccionado){
 
 poll_keymenu(0);
 
 if(EXP_cambia){
 
	 for(EXP_n=0;EXP_n<76800;EXP_n++,LCD++)*LCD=menu_p[EXP_n];
	 LCD = (unsigned char *)0x0c7b4000;
	 print((cpc_byte *)LCD+((GPC_LCD_HEIGHT*100)+180), (char*)".: EXPLORER :.", false); // LETRITAS :D

	 for(c=0,EXP_n=EXP_ini;((EXP_n<EXP_read_count)&&(c<MAX_FILES));EXP_n++){
			 print((cpc_byte *)LCD+((GPC_LCD_HEIGHT*100)+155-(c*10)), (char*)direntry[EXP_n].name, true); // LETRITAS :D
			 c++;
	 }
	 
	 print((cpc_byte *)LCD+((GPC_LCD_HEIGHT*90)+155-(EXP_pos*10)), (char*)">", false); // LETRITAS :D
	 
	 print((cpc_byte *)LCD+((GPC_LCD_HEIGHT*80)+65), (char*)"( ONLY .DSK FILES )", false); // LETRITAS :D
	 
	 		//	gm_sprintf(chStr,"R: %i N: %i P: %i I: %i", (int)read_count, (int)n, pos, ini); //para hacer el spool de comandos...
			//	print((cpc_byte *)LCD+((GPC_LCD_HEIGHT*3)+10), (char*)chStr, true); // SPOOL

	EXP_cambia=0;
 } 
 
 
 
 
 
 }
		gm_strcpy ( fichero, direntry[(EXP_pos+EXP_ini)].name );
	 
		gm_free(direntry);

		//comprobando extension
        gm_strncpy(extension, (char*)&fichero[(gm_lstrlen(fichero)-4)], 4); // grab the extension
        extension[4] = '\0'; // zero terminate string
		if(gm_memcmp(extension, ".SNA", 4)==0)
			EXP_seleccionado=2; //para que no haga un CAT de un SNA
	 
		
		//se qda pillao sino hay fichero seleccionado, claro xD
		if((EXP_seleccionado==1)&&((EXP_pos)||(EXP_ini))){
		//preparamos para el catalogo :)
			SEL_seleccionado=0;
			SEL_cambia=1;
			pituka_catalogo(fichero);
		}else if((EXP_seleccionado==2)&&((EXP_pos)||(EXP_ini))){
			     spoolkeys.comienzo=FALSE;
				 spoolkeys.contenido[0]='\0';
		}

		//preparamos por si volvemos :D
	  EXP_seleccionado=0;
	  EXP_cambia=1;
	  
  return 0;
  
  }

