/*! \file game_common.c
 *  \brief game utils
 *
 *  \version 1.0
 *
 *  In Game driver
 *
 *   Pituka - 3DS Port
 *  (c) Copyright 2009 David Colmenero (aka D_Skywalk)
 */



#ifndef GAME_COMMON_H
#define GAME_COMMON_H

void game_showscore(void);
bool game_load(void);
bool game_init(void);
void game_run(void);
bool game_save(void);
void game_options(void);

const u8 translate3DS[32];

bool InitGFX(void);
void FreeGFX(void);

void ShowSplash(void);
void ShowInfo(void);

#endif
