/* gpprintf.h - printf lib wrap for PituKa
 *
 * Copyright (c) 2005 David Skywalker <dantoine@gmail.com>
 *
 * Only for education and learn
 * 
 *
 */ 
#ifndef GPSTRINGS_H
#define GPSTRINGS_H

//STRINGS
// Map stdargs to gcclibs implementation - should be in its own file

typedef __builtin_va_list va_list;
#define va_start(v,l) __builtin_stdarg_start((v),l)
#define va_end __builtin_va_end
#define va_arg __builtin_va_arg

int abs(int n);

char *strcpy(char *dst, const char *src);

char *itoa(int v, char *dst, unsigned int base);
char *itoa_size(int v, char *dst, unsigned int base, int size, char fill_char);
int atoi(const char *str);

int GP_vsprintf(char *dest, char *fmt, va_list vl);

int GP_fprintf(F_HANDLE fp, char *fmt, ...); 

int isdigit(char c);

int gm_memcmp(const char * pt1, const  char * pt2, int size);

#endif
